t5304: use helper to report failure of "test foo = bar"
[git/git.git] / t / test-lib.sh
CommitLineData
c74c7203 1# Test framework for git. See t/README for usage.
e1970ce4
JH
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
85176d72
FC
29else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
3c8f12c9
JH
33fi
34if test -z "$TEST_OUTPUT_DIRECTORY"
35then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39fi
40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
2006f0ad
RR
42################################################################
43# It appears that people try to run tests without building...
44"$GIT_BUILD_DIR/git" >/dev/null
45if test $? != 1
46then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
49fi
50
3c8f12c9
JH
51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52export PERL_PATH SHELL_PATH
53
4cde519f
RR
54# if --tee was passed, write the output not only to the terminal, but
55# additionally to the file test-results/$BASENAME.out, too.
56case "$GIT_TEST_TEE_STARTED, $* " in
57done,*)
58 # do not redirect again
59 ;;
60*' --tee '*|*' --va'*)
2d14e13c
JK
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
4cde519f
RR
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
67 ;;
68esac
69
e1970ce4
JH
70# For repeatability, reset the environment to known value.
71LANG=C
899460f3 72LC_ALL=C
d9bdd39e 73PAGER=cat
e1970ce4 74TZ=UTC
c2116a17
JH
75TERM=dumb
76export LANG LC_ALL PAGER TERM TZ
8ff99e74 77EDITOR=:
661bfd13
SL
78# A call to "unset" with no arguments causes at least Solaris 10
79# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80# deriving from the command substitution clustered with the other
81# ones.
3c8f12c9 82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 83 my @env = keys %ENV;
730477f1
JL
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
ac001282 92 UNZIP
edb54081 93 PERF_
e2a0ccc0 94 CURL_VERBOSE
730477f1
JL
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
97 print join("\n", @vars);
98')
5adf84eb 99unset XDG_CONFIG_HOME
8bade1e1 100unset GITPERLLIB
29e55cd5
JH
101GIT_AUTHOR_EMAIL=author@example.com
102GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
103GIT_COMMITTER_EMAIL=committer@example.com
104GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 105GIT_MERGE_VERBOSITY=5
f8246281
JH
106GIT_MERGE_AUTOEDIT=no
107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 110export EDITOR
e1970ce4 111
124647c4
KB
112# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113GIT_TRACE_BARE=1
114export GIT_TRACE_BARE
115
5d9fc888
TG
116if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
120fi
121
a731fa91
EP
122# Add libc MALLOC and MALLOC_PERTURB test
123# only if we are not executing the test with valgrind
1b3185fc 124if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 125 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
126then
127 setup_malloc_check () {
128 : nothing
129 }
130 teardown_malloc_check () {
131 : nothing
132 }
133else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
137 }
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
140 }
141fi
a731fa91 142
886a3907
JH
143# Protect ourselves from common misconfiguration to export
144# CDPATH into the environment
145unset CDPATH
146
5565f47c 147unset GREP_OPTIONS
ac001282 148unset UNZIP
5565f47c 149
3d5c0cc9 150case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1511|2|true)
152 echo "* warning: Some tests will not work if GIT_TRACE" \
153 "is set as to trace on STDERR ! *"
154 echo "* warning: Please set GIT_TRACE to something" \
155 "other than 1, 2 or true ! *"
156 ;;
6ce4e61f
CC
157esac
158
cd3c095c
JH
159# Convenience
160#
161# A regexp to match 5 and 40 hexdigits
162_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
163_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
164
3749fde5
JH
165# Zero SHA-1
166_z40=0000000000000000000000000000000000000000
167
3f4ab627
JH
168# Line feed
169LF='
170'
171
342e9ef2
TR
172export _x05 _x40 _z40 LF
173
e1970ce4
JH
174# Each test should start with something like this, after copyright notices:
175#
176# test_description='Description of this test...
177# This test checks if command xyzzy does the right thing...
178# '
179# . ./test-lib.sh
c2116a17
JH
180[ "x$ORIGINAL_TERM" != "xdumb" ] && (
181 TERM=$ORIGINAL_TERM &&
182 export TERM &&
183 [ -t 1 ] &&
184 tput bold >/dev/null 2>&1 &&
185 tput setaf 1 >/dev/null 2>&1 &&
186 tput sgr0 >/dev/null 2>&1
187 ) &&
55db1df0 188 color=t
e1970ce4 189
e1970ce4
JH
190while test "$#" -ne 0
191do
192 case "$1" in
193 -d|--d|--de|--deb|--debu|--debug)
194 debug=t; shift ;;
886856ab
JH
195 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
196 immediate=t; shift ;;
5e2c08c6 197 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 198 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
0445e6f0
IB
199 -r)
200 shift; test "$#" -ne 0 || {
201 echo 'error: -r requires an argument' >&2;
202 exit 1;
203 }
204 run_list=$1; shift ;;
205 --run=*)
206 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
e1970ce4 207 -h|--h|--he|--hel|--help)
570f3226 208 help=t; shift ;;
e1970ce4
JH
209 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
210 verbose=t; shift ;;
ff09af3f
TR
211 --verbose-only=*)
212 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
213 shift ;;
1ece1274 214 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
215 # Ignore --quiet under a TAP::Harness. Saying how many tests
216 # passed without the ok/not ok details is always an error.
217 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
218 --with-dashes)
219 with_dashes=t; shift ;;
55db1df0 220 --no-color)
faa4bc35 221 color=; shift ;;
4e1be63c 222 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
223 valgrind=memcheck
224 shift ;;
225 --valgrind=*)
226 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
227 shift ;;
5dfc368f
TR
228 --valgrind-only=*)
229 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
230 shift ;;
44138559
JS
231 --tee)
232 shift ;; # was handled already
f423ef5f
JK
233 --root=*)
234 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
235 shift ;;
e1970ce4 236 *)
1f729dca 237 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
238 esac
239done
240
26a07309 241if test -n "$valgrind_only"
5dfc368f
TR
242then
243 test -z "$valgrind" && valgrind=memcheck
244 test -z "$verbose" && verbose_only="$valgrind_only"
245elif test -n "$valgrind"
246then
247 verbose=t
248fi
952af351 249
1c0cc756
RJ
250if test -n "$color"
251then
55db1df0 252 say_color () {
c2116a17
JH
253 (
254 TERM=$ORIGINAL_TERM
255 export TERM
55db1df0 256 case "$1" in
1c0cc756
RJ
257 error)
258 tput bold; tput setaf 1;; # bold red
259 skip)
b8fc855a 260 tput setaf 4;; # blue
e8e51955
AS
261 warn)
262 tput setaf 3;; # brown/yellow
1c0cc756 263 pass)
0a6d4751 264 tput setaf 2;; # green
1c0cc756 265 info)
0a6d4751 266 tput setaf 6;; # cyan
1c0cc756
RJ
267 *)
268 test -n "$quiet" && return;;
55db1df0
PH
269 esac
270 shift
5099b99d 271 printf "%s" "$*"
55db1df0 272 tput sgr0
b8eecafd 273 echo
c2116a17 274 )
55db1df0
PH
275 }
276else
277 say_color() {
1ece1274 278 test -z "$1" && test -n "$quiet" && return
55db1df0 279 shift
7bc0911d 280 printf "%s\n" "$*"
55db1df0
PH
281 }
282fi
283
284error () {
285 say_color error "error: $*"
6e7b5aaf 286 GIT_EXIT_OK=t
55db1df0
PH
287 exit 1
288}
289
290say () {
291 say_color info "$*"
292}
293
570f3226
MB
294test "${test_description}" != "" ||
295error "Test script did not set test_description."
296
297if test "$help" = "t"
298then
cb1aefda 299 printf '%s\n' "$test_description"
570f3226
MB
300 exit 0
301fi
302
4d9d62fa 303exec 5>&1
781f76b1 304exec 6<&0
e1970ce4
JH
305if test "$verbose" = "t"
306then
307 exec 4>&2 3>&1
308else
309 exec 4>/dev/null 3>/dev/null
310fi
311
312test_failure=0
313test_count=0
41ac414e
JH
314test_fixed=0
315test_broken=0
2d84e9fb 316test_success=0
e1970ce4 317
d998bd4a
ÆAB
318test_external_has_tap=0
319
faa4bc35 320die () {
6e7b5aaf
CB
321 code=$?
322 if test -n "$GIT_EXIT_OK"
323 then
324 exit $code
325 else
326 echo >&5 "FATAL: Unexpected exit with code $code"
327 exit 1
328 fi
faa4bc35
CB
329}
330
6e7b5aaf 331GIT_EXIT_OK=
35641310 332trap 'die' EXIT
41184273 333
12a29b1a
TR
334# The user-facing functions are loaded from a separate file so that
335# test_perf subshells can have them too
3c8f12c9 336. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 337
886856ab 338# You are not expected to call test_ok_ and test_failure_ directly, use
3fa36666 339# the test_expect_* functions instead.
886856ab
JH
340
341test_ok_ () {
d5d9de1b 342 test_success=$(($test_success + 1))
633fe50a 343 say_color "" "ok $test_count - $@"
e1970ce4
JH
344}
345
886856ab 346test_failure_ () {
d5d9de1b 347 test_failure=$(($test_failure + 1))
633fe50a 348 say_color error "not ok $test_count - $1"
bf0dd8a8 349 shift
cb1aefda 350 printf '%s\n' "$*" | sed -e 's/^/# /'
6e7b5aaf 351 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
352}
353
41ac414e 354test_known_broken_ok_ () {
41ac414e 355 test_fixed=$(($test_fixed+1))
633fe50a 356 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
357}
358
359test_known_broken_failure_ () {
41ac414e 360 test_broken=$(($test_broken+1))
633fe50a 361 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 362}
886856ab
JH
363
364test_debug () {
8e832ebc 365 test "$debug" = "" || eval "$1"
e1970ce4
JH
366}
367
e6a6ddc9
TR
368match_pattern_list () {
369 arg="$1"
370 shift
371 test -z "$*" && return 1
372 for pattern_
373 do
374 case "$arg" in
375 $pattern_)
376 return 0
377 esac
378 done
379 return 1
380}
381
0445e6f0
IB
382match_test_selector_list () {
383 title="$1"
384 shift
385 arg="$1"
386 shift
387 test -z "$1" && return 0
388
389 # Both commas and whitespace are accepted as separators.
390 OLDIFS=$IFS
391 IFS=' ,'
392 set -- $1
393 IFS=$OLDIFS
394
395 # If the first selector is negative we include by default.
396 include=
397 case "$1" in
398 !*) include=t ;;
399 esac
400
401 for selector
402 do
403 orig_selector=$selector
404
405 positive=t
406 case "$selector" in
407 !*)
408 positive=
409 selector=${selector##?}
410 ;;
411 esac
412
413 test -z "$selector" && continue
414
415 case "$selector" in
416 *-*)
417 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
418 then
419 echo "error: $title: invalid non-numeric in range" \
420 "start: '$orig_selector'" >&2
421 exit 1
422 fi
423 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
424 then
425 echo "error: $title: invalid non-numeric in range" \
426 "end: '$orig_selector'" >&2
427 exit 1
428 fi
429 ;;
430 *)
431 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
432 then
433 echo "error: $title: invalid non-numeric in test" \
434 "selector: '$orig_selector'" >&2
435 exit 1
436 fi
437 esac
438
439 # Short cut for "obvious" cases
440 test -z "$include" && test -z "$positive" && continue
441 test -n "$include" && test -n "$positive" && continue
442
443 case "$selector" in
444 -*)
445 if test $arg -le ${selector#-}
446 then
447 include=$positive
448 fi
449 ;;
450 *-)
451 if test $arg -ge ${selector%-}
452 then
453 include=$positive
454 fi
455 ;;
456 *-*)
457 if test ${selector%%-*} -le $arg \
458 && test $arg -le ${selector#*-}
459 then
460 include=$positive
461 fi
462 ;;
463 *)
464 if test $arg -eq $selector
465 then
466 include=$positive
467 fi
468 ;;
469 esac
470 done
471
472 test -n "$include"
473}
474
ff09af3f
TR
475maybe_teardown_verbose () {
476 test -z "$verbose_only" && return
477 exec 4>/dev/null 3>/dev/null
478 verbose=
479}
480
481last_verbose=t
482maybe_setup_verbose () {
483 test -z "$verbose_only" && return
26a07309 484 if match_pattern_list $test_count $verbose_only
ff09af3f
TR
485 then
486 exec 4>&2 3>&1
487 # Emit a delimiting blank line when going from
488 # non-verbose to verbose. Within verbose mode the
489 # delimiter is printed by test_expect_*. The choice
490 # of the initial $last_verbose is such that before
491 # test 1, we do not print it.
492 test -z "$last_verbose" && echo >&3 ""
493 verbose=t
494 else
495 exec 4>/dev/null 3>/dev/null
496 verbose=
497 fi
498 last_verbose=$verbose
499}
500
5dfc368f
TR
501maybe_teardown_valgrind () {
502 test -z "$GIT_VALGRIND" && return
503 GIT_VALGRIND_ENABLED=
504}
505
506maybe_setup_valgrind () {
507 test -z "$GIT_VALGRIND" && return
26a07309 508 if test -z "$valgrind_only"
5dfc368f
TR
509 then
510 GIT_VALGRIND_ENABLED=t
511 return
512 fi
513 GIT_VALGRIND_ENABLED=
514 if match_pattern_list $test_count $valgrind_only
515 then
516 GIT_VALGRIND_ENABLED=t
517 fi
518}
519
a7c58f28
JN
520test_eval_ () {
521 # This is a separate function because some tests use
522 # "return" to end a test_expect_success block early.
781f76b1 523 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
524}
525
4d9d62fa 526test_run_ () {
b6b0afdc 527 test_cleanup=:
b586744a 528 expecting_failure=$2
a57397b0 529 setup_malloc_check
a7c58f28 530 test_eval_ "$1"
b6b0afdc 531 eval_ret=$?
a57397b0 532 teardown_malloc_check
b586744a
JH
533
534 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
535 then
1b3185fc 536 setup_malloc_check
a7c58f28 537 test_eval_ "$test_cleanup"
1b3185fc 538 teardown_malloc_check
b586744a 539 fi
1c0cc756
RJ
540 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
541 then
57e1538a
ÆAB
542 echo ""
543 fi
aa0bcf96 544 return "$eval_ret"
4d9d62fa
PR
545}
546
ae75342c 547test_start_ () {
8586f98b 548 test_count=$(($test_count+1))
ff09af3f 549 maybe_setup_verbose
5dfc368f 550 maybe_setup_valgrind
ae75342c
TR
551}
552
553test_finish_ () {
554 echo >&3 ""
5dfc368f 555 maybe_teardown_valgrind
ff09af3f 556 maybe_teardown_verbose
ae75342c
TR
557}
558
559test_skip () {
04ece593 560 to_skip=
ef2ac68d 561 skipped_reason=
e6a6ddc9
TR
562 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
563 then
564 to_skip=t
ef2ac68d 565 skipped_reason="GIT_SKIP_TESTS"
e6a6ddc9 566 fi
05236a5e
JN
567 if test -z "$to_skip" && test -n "$test_prereq" &&
568 ! test_have_prereq "$test_prereq"
a7bb3940
JS
569 then
570 to_skip=t
ef2ac68d 571
07431fc8 572 of_prereq=
05236a5e 573 if test "$missing_prereq" != "$test_prereq"
07431fc8 574 then
05236a5e 575 of_prereq=" of $test_prereq"
07431fc8 576 fi
ef2ac68d
IB
577 skipped_reason="missing $missing_prereq${of_prereq}"
578 fi
0445e6f0
IB
579 if test -z "$to_skip" && test -n "$run_list" &&
580 ! match_test_selector_list '--run' $test_count "$run_list"
581 then
582 to_skip=t
583 skipped_reason="--run"
584 fi
07431fc8 585
ef2ac68d
IB
586 case "$to_skip" in
587 t)
633fe50a 588 say_color skip >&3 "skipping test: $@"
ef2ac68d 589 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
04ece593
JH
590 : true
591 ;;
592 *)
593 false
594 ;;
595 esac
596}
597
342e9ef2
TR
598# stub; perf-lib overrides it
599test_at_end_hook_ () {
600 :
601}
602
e1970ce4 603test_done () {
6e7b5aaf 604 GIT_EXIT_OK=t
2d84e9fb 605
1c0cc756
RJ
606 if test -z "$HARNESS_ACTIVE"
607 then
342e9ef2 608 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 609 mkdir -p "$test_results_dir"
dd78478f
FC
610 base=${0##*/}
611 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 612
c54e6be7
ML
613 cat >>"$test_results_path" <<-EOF
614 total $test_count
615 success $test_success
616 fixed $test_fixed
617 broken $test_broken
618 failed $test_failure
619
620 EOF
8ef1abe5 621 fi
41ac414e
JH
622
623 if test "$test_fixed" != 0
624 then
633fe50a 625 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
626 fi
627 if test "$test_broken" != 0
628 then
633fe50a 629 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
630 fi
631 if test "$test_broken" != 0 || test "$test_fixed" != 0
632 then
633 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
634 msg="remaining $test_remaining test(s)"
11d54b8b 635 else
b73d9a23 636 test_remaining=$test_count
11d54b8b 637 msg="$test_count test(s)"
41ac414e 638 fi
e1970ce4 639 case "$test_failure" in
10b94e28 640 0)
5099b99d 641 # Maybe print SKIP message
bf4b7219
RJ
642 if test -n "$skip_all" && test $test_count -gt 0
643 then
644 error "Can't use skip_all after running some tests"
645 fi
5099b99d
ÆAB
646 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
647
1c0cc756
RJ
648 if test $test_external_has_tap -eq 0
649 then
b73d9a23 650 if test $test_remaining -gt 0
d87bd7c1 651 then
633fe50a 652 say_color pass "# passed all $msg"
d87bd7c1 653 fi
633fe50a 654 say "1..$test_count$skip_all"
d998bd4a 655 fi
abc5d372
JS
656
657 test -d "$remove_trash" &&
658 cd "$(dirname "$remove_trash")" &&
659 rm -rf "$(basename "$remove_trash")"
660
342e9ef2
TR
661 test_at_end_hook_
662
e1970ce4
JH
663 exit 0 ;;
664
665 *)
1c0cc756
RJ
666 if test $test_external_has_tap -eq 0
667 then
633fe50a
TR
668 say_color error "# failed $test_failure among $msg"
669 say "1..$test_count"
d998bd4a 670 fi
5099b99d 671
e1970ce4
JH
672 exit 1 ;;
673
674 esac
675}
676
e4597aae 677if test -n "$valgrind"
4e1be63c 678then
4e1be63c
JS
679 make_symlink () {
680 test -h "$2" &&
681 test "$1" = "$(readlink "$2")" || {
682 # be super paranoid
683 if mkdir "$2".lock
684 then
685 rm -f "$2" &&
686 ln -s "$1" "$2" &&
687 rm -r "$2".lock
688 else
689 while test -d "$2".lock
690 do
691 say "Waiting for lock on $2."
692 sleep 1
693 done
694 fi
695 }
696 }
697
698 make_valgrind_symlink () {
36bfb0e5 699 # handle only executables, unless they are shell libraries that
11d62145 700 # need to be in the exec-path.
36bfb0e5 701 test -x "$1" ||
11d62145 702 test "# " = "$(head -c 2 <"$1")" ||
36bfb0e5 703 return;
4e1be63c
JS
704
705 base=$(basename "$1")
6cec5c68 706 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
707 # do not override scripts
708 if test -x "$symlink_target" &&
709 test ! -d "$symlink_target" &&
710 test "#!" != "$(head -c 2 < "$symlink_target")"
711 then
712 symlink_target=../valgrind.sh
713 fi
efd92ffd
JS
714 case "$base" in
715 *.sh|*.perl)
716 symlink_target=../unprocessed-script
717 esac
4e1be63c
JS
718 # create the link, or replace it if it is out of date
719 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
720 }
721
26a07309
TR
722 # override all git executables in TEST_DIRECTORY/..
723 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
724 mkdir -p "$GIT_VALGRIND"/bin
725 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
726 do
727 make_valgrind_symlink $file
728 done
729 # special-case the mergetools loadables
730 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
731 OLDIFS=$IFS
732 IFS=:
733 for path in $PATH
734 do
735 ls "$path"/git-* 2> /dev/null |
736 while read file
ad0e6233 737 do
26a07309 738 make_valgrind_symlink "$file"
ad0e6233 739 done
26a07309
TR
740 done
741 IFS=$OLDIFS
4e1be63c
JS
742 PATH=$GIT_VALGRIND/bin:$PATH
743 GIT_EXEC_PATH=$GIT_VALGRIND/bin
744 export GIT_VALGRIND
952af351
TR
745 GIT_VALGRIND_MODE="$valgrind"
746 export GIT_VALGRIND_MODE
5dfc368f 747 GIT_VALGRIND_ENABLED=t
26a07309 748 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
5dfc368f 749 export GIT_VALGRIND_ENABLED
1c0cc756
RJ
750elif test -n "$GIT_TEST_INSTALLED"
751then
e4597aae
MO
752 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
753 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 754 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
755 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
756else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 757 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
758 if ! test -x "$git_bin_dir/git"
759 then
760 if test -z "$with_dashes"
761 then
e4597aae
MO
762 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
763 fi
764 with_dashes=t
765 fi
766 PATH="$git_bin_dir:$PATH"
6cec5c68 767 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
768 if test -n "$with_dashes"
769 then
6cec5c68 770 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 771 fi
4e1be63c 772fi
6cec5c68 773GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 774GIT_CONFIG_NOSYSTEM=1
3c995beb 775GIT_ATTR_NOSYSTEM=1
8f323c00 776export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 777
5e87eae9
JH
778if test -z "$GIT_TEST_CMP"
779then
780 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
781 then
782 GIT_TEST_CMP="$DIFF -c"
783 else
784 GIT_TEST_CMP="$DIFF -u"
785 fi
786fi
787
6cec5c68 788GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 789export GITPERLLIB
6cec5c68 790test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
791 error "You haven't built things yet, have you?"
792}
e1970ce4 793
1c0cc756
RJ
794if ! test -x "$GIT_BUILD_DIR"/test-chmtime
795then
56cf9806
EW
796 echo >&2 'You need to build test-chmtime:'
797 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
798 exit 1
799fi
800
e1970ce4 801# Test repository
002d4ce8
JK
802TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
803test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
804case "$TRASH_DIRECTORY" in
805/*) ;; # absolute path is good
806 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 807esac
91c8b825 808test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 809rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 810 GIT_EXIT_OK=t
8d14ac94
JH
811 echo >&5 "FATAL: Cannot prepare test area"
812 exit 1
813}
814
90cff968 815HOME="$TRASH_DIRECTORY"
0ea47f9d
JH
816GNUPGHOME="$HOME/gnupg-home-not-used"
817export HOME GNUPGHOME
90cff968 818
1c0cc756
RJ
819if test -z "$TEST_NO_CREATE_REPO"
820then
38b074de 821 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 822else
38b074de 823 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 824fi
1bd9c648
LW
825# Use -P to resolve symlinks in our working directory so that the cwd
826# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 827cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 828
d5d9de1b
JS
829this_test=${0##*/}
830this_test=${this_test%%-*}
e6a6ddc9
TR
831if match_pattern_list "$this_test" $GIT_SKIP_TESTS
832then
833 say_color info >&3 "skipping test $this_test altogether"
834 skip_all="skip all tests in $this_test"
835 test_done
836fi
f17e9fbb 837
8648732e
BC
838# Provide an implementation of the 'yes' utility
839yes () {
840 if test $# = 0
841 then
842 y=y
843 else
844 y="$*"
845 fi
846
847 while echo "$y"
848 do
849 :
850 done
851}
852
f17e9fbb
JS
853# Fix some commands on Windows
854case $(uname -s) in
855*MINGW*)
856 # Windows has its own (incompatible) sort and find
857 sort () {
858 /usr/bin/sort "$@"
859 }
860 find () {
861 /usr/bin/find "$@"
862 }
5397ea31
JS
863 sum () {
864 md5sum "$@"
865 }
4114156a
JS
866 # git sees Windows-style pwd
867 pwd () {
868 builtin pwd -W
869 }
ee9fb68c 870 # no POSIX permissions
6fd1106a 871 # backslashes in pathspec are converted to '/'
fb9a2bea 872 # exec does not inherit the PID
a94114ad 873 test_set_prereq MINGW
5f4e02e5 874 test_set_prereq NATIVE_CRLF
a31d0665 875 test_set_prereq SED_STRIPS_CR
97669eed 876 test_set_prereq GREP_STRIPS_CR
4d715ac0 877 GIT_TEST_CMP=mingw_test_cmp
a31d0665
RJ
878 ;;
879*CYGWIN*)
880 test_set_prereq POSIXPERM
a31d0665 881 test_set_prereq EXECKEEPSPID
cfa96496 882 test_set_prereq CYGWIN
a31d0665 883 test_set_prereq SED_STRIPS_CR
97669eed 884 test_set_prereq GREP_STRIPS_CR
ee9fb68c
JS
885 ;;
886*)
887 test_set_prereq POSIXPERM
6fd1106a 888 test_set_prereq BSLASHPSPEC
fb9a2bea 889 test_set_prereq EXECKEEPSPID
f17e9fbb
JS
890 ;;
891esac
704a3143 892
b082687c 893( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 894test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 895test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 896test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 897test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 898
bb946bba 899# Can we rely on git's output in the C locale?
30955229
JN
900if test -n "$GETTEXT_POISON"
901then
902 GIT_GETTEXT_POISON=YesPlease
903 export GIT_GETTEXT_POISON
5e9637c6 904 test_set_prereq GETTEXT_POISON
30955229
JN
905else
906 test_set_prereq C_LOCALE_OUTPUT
907fi
bb946bba 908
cabdee2c
JH
909# Use this instead of test_cmp to compare files that contain expected and
910# actual output from git commands that can be translated. When running
911# under GETTEXT_POISON this pretends that the command produced expected
912# results.
913test_i18ncmp () {
914 test -n "$GETTEXT_POISON" || test_cmp "$@"
915}
916
127df8c6
JH
917# Use this instead of "grep expected-string actual" to see if the
918# output from a git command that can be translated either contains an
919# expected string, or does not contain an unwanted one. When running
920# under GETTEXT_POISON this pretends that the command produced expected
921# results.
922test_i18ngrep () {
923 if test -n "$GETTEXT_POISON"
924 then
925 : # pretend success
926 elif test "x!" = "x$1"
927 then
928 shift
929 ! grep "$@"
930 else
931 grep "$@"
932 fi
933}
934
20073274
AS
935test_lazy_prereq PIPE '
936 # test whether the filesystem supports FIFOs
9443605b
ML
937 case $(uname -s) in
938 CYGWIN*)
939 false
940 ;;
941 *)
942 rm -f testfifo && mkfifo testfifo
943 ;;
944 esac
20073274
AS
945'
946
04083f27
JH
947test_lazy_prereq SYMLINKS '
948 # test whether the filesystem supports symbolic links
949 ln -s x y && test -h y
950'
c91cfd19 951
b018c735
JN
952test_lazy_prereq FILEMODE '
953 test "$(git config --bool core.filemode)" = true
954'
955
ac39aa61
MG
956test_lazy_prereq CASE_INSENSITIVE_FS '
957 echo good >CamelCase &&
958 echo bad >camelcase &&
959 test "$(cat CamelCase)" != good
960'
961
5b0b5dd4
MG
962test_lazy_prereq UTF8_NFD_TO_NFC '
963 # check whether FS converts nfd unicode to nfc
964 auml=$(printf "\303\244")
965 aumlcdiar=$(printf "\141\314\210")
966 >"$auml" &&
967 case "$(echo *)" in
968 "$aumlcdiar")
969 true ;;
970 *)
971 false ;;
972 esac
973'
974
09feffb6
JK
975test_lazy_prereq AUTOIDENT '
976 sane_unset GIT_AUTHOR_NAME &&
977 sane_unset GIT_AUTHOR_EMAIL &&
978 git var GIT_AUTHOR_IDENT
979'
980
6219bb22
JH
981test_lazy_prereq EXPENSIVE '
982 test -n "$GIT_TEST_LONG"
983'
984
e1ecd9e3
JH
985test_lazy_prereq USR_BIN_TIME '
986 test -x /usr/bin/time
987'
988
c91cfd19
ÆAB
989# When the tests are run as root, permission tests will report that
990# things are writable when they shouldn't be.
991test -w / || test_set_prereq SANITY
f838ce58
JK
992
993GIT_UNZIP=${GIT_UNZIP:-unzip}
994test_lazy_prereq UNZIP '
995 "$GIT_UNZIP" -v
996 test $? -ne 127
997'